Grid

    <style>
    #page {
      position: absolute;
      z-index: 10;
      left: 0;
      top: 0;
      bottom: 0;
      right: 0;
    }
    </style>
    <link rel="stylesheet" href="./grid.css" />
    <div id="page" class="grid"></div>

    let grid = new ipushpull.Grid('page');

### Hierarchy

- Grid

### Implements

- IGrid

## Index

### Constructors

- constructor

### Properties

- Events
- _editing
- _gridlines
- _hasFocus
- _headings
- accessRanges
- arrowKeyDown
- boxEl
- buttonPopper
- buttons
- canEdit
- cellsOffsetX
- cellsOffsetY
- clickedAt
- columnCells
- columnsCellsEl
- columnsEl
- commonCells
- commonCellsEl
- commonEl
- content
- contrast
- ctrlDown
- dirty
- disallowSelection
- doubleClicked
- editEl
- editingCell
- fit
- found
- freezeCol
- freezeHeight
- freezeRow
- freezeWidth
- gridCells
- gridColumnHeadingCells
- gridRowHeadingCells
- headingsColumnsCellsEl
- headingsColumnsEl
- headingsCommonCellsEl
- headingsCommonEl
- headingsEl
- headingsRowsCellsEl
- headingsRowsEl
- headingsTimer
- height
- hiddenColumns
- highlights
- historyClick
- initialized
- keyValue
- mainBoxEl
- mainCellsEl
- mainEl
- mainElRect
- mergeEl
- offsetX
- offsetY
- originalContent
- pageEl
- pageElRect
- popperEl
- ps
- ref
- rendering
- resizing
- rightClick
- rowCells
- rows
- rowsCellsEl
- rowsColumns
- rowsEl
- rowsRows
- rowsToHide
- scale
- scaleEl
- scrollEl
- scrollTimer
- selectorColumns
- selectorColumnsContainer
- selectorColumnsContainerPosition
- selectorCommon
- selectorCommonContainer
- selectorCommonContainerPosition
- selectorMain
- selectorMainContainer
- selectorMainContainerPosition
- selectorRows
- selectorRowsContainer
- selectorRowsContainerPosition
- selectorWrapper
- shiftDown
- styles
- touch
- tracking
- trackingData
- trackingUsers
- unshift
- userId
- width
- wrapperEl
- wrapperElRect

### Accessors

- editing
- gridlines
- hasFocus
- headings

### Methods

- applyButtons
- applyCellUpdate
- applyFilters
- applyHeadingCellsFreeze
- applyRanges
- applyScale
- applySorting
- applyState
- applyStyles
- cancelCellEdit
- clearFound
- clearSelector
- clearTrackingData
- createListeners
- destroy
- destroyListeners
- destroyPopper
- dom
- domHeadings
- emitSelected
- find
- getCell
- getContentHtml
- getGridCell
- getGridCellByTarget
- getTrackingUser
- init
- isFullyVisible
- isInsideSelection
- isRightClick
- isTarget
- isVisible
- onCellUpdates
- onCtrlNavigate
- onKeydown
- onKeyup
- onMouseDown
- onMouseMove
- onMouseUp
- onResize
- onResizeHandle
- render
- reset
- scaleDimension
- selectNextCell
- setCellSelection
- setContent
- setContrast
- setDeltaContent
- setElementSizes
- setFreeze
- setFreezeSizes
- setHiddenColumns
- setOption
- setPositions
- setSelector
- setSelectorByRef
- setSize
- update
- updateButtons
- updateFit
- updateFreeze
- updateHeadings
- updateHistoryCells
- updateRanges
- updateSelector
- updateSize
- updateSoftMerges
- updateSorting
- updateState
- updateStyles
- updateTrackingData

### Object literals

- selection
- state

## Constructors

### constructor

- new Grid(ref: string | HTMLDivElement, options?: IGridOptions): Grid

- - Defined in Grid3/Grid.ts:334

  #### Parameters

  - ##### ref: string | HTMLDivElement

  - ##### Optional options: IGridOptions

  #### Returns Grid

## Properties

### Events

Events: IGridEvents

Implementation of IGrid.Events

- Defined in Grid3/Grid.ts:192

### Private _editing

_editing: boolean = false

- Defined in Grid3/Grid.ts:297

### Private _gridlines

_gridlines: boolean = false

- Defined in Grid3/Grid.ts:299

### Private _hasFocus

_hasFocus: boolean = false

- Defined in Grid3/Grid.ts:298

### Private _headings

_headings: boolean = false

- Defined in Grid3/Grid.ts:300

### Private accessRanges

accessRanges: any = []

- Defined in Grid3/Grid.ts:307

### Private arrowKeyDown

arrowKeyDown: boolean = false

- Defined in Grid3/Grid.ts:332

### Private boxEl

boxEl: HTMLDivElement

- Defined in Grid3/Grid.ts:226

### Private buttonPopper

buttonPopper: any

- Defined in Grid3/Grid.ts:327

### Private buttons

buttons: IGridButtonIndexes = []

- Defined in Grid3/Grid.ts:304

### canEdit

canEdit: boolean = true

Implementation of IGrid.canEdit

- Defined in Grid3/Grid.ts:178

### Private cellsOffsetX

cellsOffsetX: number = 0

- Defined in Grid3/Grid.ts:216

### Private cellsOffsetY

cellsOffsetY: number = 0

- Defined in Grid3/Grid.ts:217

### Private clickedAt

clickedAt: number = 0

- Defined in Grid3/Grid.ts:296

### Private columnCells

columnCells: IGridCells = [[]]

- Defined in Grid3/Grid.ts:198

### Private columnsCellsEl

columnsCellsEl: HTMLDivElement

- Defined in Grid3/Grid.ts:254

### Private columnsEl

columnsEl: HTMLDivElement

- Defined in Grid3/Grid.ts:253

### Private commonCells

commonCells: IGridCells = [[]]

- Defined in Grid3/Grid.ts:197

### Private commonCellsEl

commonCellsEl: HTMLDivElement

- Defined in Grid3/Grid.ts:265

### Private commonEl

commonEl: HTMLDivElement

- Defined in Grid3/Grid.ts:264

### Private content

content: IGridPageContent = []

- Defined in Grid3/Grid.ts:289

### contrast

contrast: string = "light"

Implementation of IGrid.contrast

- Defined in Grid3/Grid.ts:176

### Private ctrlDown

ctrlDown: boolean = false

- Defined in Grid3/Grid.ts:330

### Private dirty

dirty: boolean = false

- Defined in Grid3/Grid.ts:301

### disallowSelection

disallowSelection: boolean = false

Implementation of IGrid.disallowSelection

- Defined in Grid3/Grid.ts:177

### Private doubleClicked

doubleClicked: boolean = false

- Defined in Grid3/Grid.ts:293

### Private editEl

editEl: HTMLDivElement

- Defined in Grid3/Grid.ts:227

### Private editingCell

editingCell: IGridCell | undefined

- Defined in Grid3/Grid.ts:326

### fit

fit: string = "scroll"

Implementation of IGrid.fit

- Defined in Grid3/Grid.ts:172

### Private found

found: IPageContent = []

- Defined in Grid3/Grid.ts:306

### freezeCol

freezeCol: number = 0

- Defined in Grid3/Grid.ts:170

### Private freezeHeight

freezeHeight: number = 0

- Defined in Grid3/Grid.ts:209

### freezeRow

freezeRow: number = 0

- Defined in Grid3/Grid.ts:171

### Private freezeWidth

freezeWidth: number = 0

- Defined in Grid3/Grid.ts:210

### Private gridCells

gridCells: IGridCells = [[]]

- Defined in Grid3/Grid.ts:196

### Private gridColumnHeadingCells

gridColumnHeadingCells: IGridHeadingCell[] = []

- Defined in Grid3/Grid.ts:201

### Private gridRowHeadingCells

gridRowHeadingCells: IGridHeadingCell[] = []

- Defined in Grid3/Grid.ts:200

### Private headingsColumnsCellsEl

headingsColumnsCellsEl: HTMLDivElement

- Defined in Grid3/Grid.ts:232

### Private headingsColumnsEl

headingsColumnsEl: HTMLDivElement

- Defined in Grid3/Grid.ts:231

### Private headingsCommonCellsEl

headingsCommonCellsEl: HTMLDivElement

- Defined in Grid3/Grid.ts:236

### Private headingsCommonEl

headingsCommonEl: HTMLDivElement

- Defined in Grid3/Grid.ts:235

### Private headingsEl

headingsEl: HTMLDivElement

- Defined in Grid3/Grid.ts:230

### Private headingsRowsCellsEl

headingsRowsCellsEl: HTMLDivElement

- Defined in Grid3/Grid.ts:234

### Private headingsRowsEl

headingsRowsEl: HTMLDivElement

- Defined in Grid3/Grid.ts:233

### Private headingsTimer

headingsTimer: any

- Defined in Grid3/Grid.ts:308

### Private height

height: number = 0

- Defined in Grid3/Grid.ts:195

### Private hiddenColumns

hiddenColumns: number[] = []

- Defined in Grid3/Grid.ts:303

### highlights

highlights: boolean = false

Implementation of IGrid.highlights

- Defined in Grid3/Grid.ts:173

### Private historyClick

historyClick: boolean = false

- Defined in Grid3/Grid.ts:294

### Private initialized

initialized: boolean = false

- Defined in Grid3/Grid.ts:285

### Private keyValue

keyValue: string | undefined

- Defined in Grid3/Grid.ts:334

### Private mainBoxEl

mainBoxEl: HTMLDivElement

- Defined in Grid3/Grid.ts:249

### Private mainCellsEl

mainCellsEl: HTMLDivElement

- Defined in Grid3/Grid.ts:248

### Private mainEl

mainEl: HTMLDivElement

- Defined in Grid3/Grid.ts:246

### Private mainElRect

mainElRect: ClientRect

- Defined in Grid3/Grid.ts:247

### Private mergeEl

mergeEl: HTMLDivElement

- Defined in Grid3/Grid.ts:222

### Private offsetX

offsetX: number = 0

- Defined in Grid3/Grid.ts:214

### Private offsetY

offsetY: number = 0

- Defined in Grid3/Grid.ts:215

### Private originalContent

originalContent: IPageContent = []

- Defined in Grid3/Grid.ts:288

### Private pageEl

pageEl: HTMLDivElement

- Defined in Grid3/Grid.ts:220

### Private pageElRect

pageElRect: ClientRect

- Defined in Grid3/Grid.ts:221

### Private popperEl

popperEl: HTMLDivElement

- Defined in Grid3/Grid.ts:224

### Private ps

ps: IGridScrollbars

- Defined in Grid3/Grid.ts:287

### ref

ref: string | HTMLDivElement

Implementation of IGrid.ref

- Defined in Grid3/Grid.ts:336

### Private rendering

rendering: boolean = false

- Defined in Grid3/Grid.ts:286

### Private resizing

resizing: boolean = false

- Defined in Grid3/Grid.ts:292

### Private rightClick

rightClick: boolean = false

- Defined in Grid3/Grid.ts:295

### Private rowCells

rowCells: HTMLDivElement[] = []

- Defined in Grid3/Grid.ts:207

### Private rows

rows: IGridRow[] = []

- Defined in Grid3/Grid.ts:203

### Private rowsCellsEl

rowsCellsEl: HTMLDivElement

- Defined in Grid3/Grid.ts:260

### Private rowsColumns

rowsColumns: IGridRow[] = []

- Defined in Grid3/Grid.ts:204

### Private rowsEl

rowsEl: HTMLDivElement

- Defined in Grid3/Grid.ts:259

### Private rowsRows

rowsRows: IGridRow[] = []

- Defined in Grid3/Grid.ts:205

### Private rowsToHide

rowsToHide: number[] = []

- Defined in Grid3/Grid.ts:212

### Private scale

scale: number = 1

- Defined in Grid3/Grid.ts:211

### Private scaleEl

scaleEl: HTMLDivElement

- Defined in Grid3/Grid.ts:223

### Private scrollEl

scrollEl: HTMLDivElement

- Defined in Grid3/Grid.ts:225

### Private scrollTimer

scrollTimer: any = null

- Defined in Grid3/Grid.ts:2327

### Private selectorColumns

selectorColumns: HTMLDivElement

- Defined in Grid3/Grid.ts:277

### Private selectorColumnsContainer

selectorColumnsContainer: HTMLDivElement

- Defined in Grid3/Grid.ts:275

### Private selectorColumnsContainerPosition

selectorColumnsContainerPosition: HTMLDivElement

- Defined in Grid3/Grid.ts:276

### Private selectorCommon

selectorCommon: HTMLDivElement

- Defined in Grid3/Grid.ts:283

### Private selectorCommonContainer

selectorCommonContainer: HTMLDivElement

- Defined in Grid3/Grid.ts:281

### Private selectorCommonContainerPosition

selectorCommonContainerPosition: HTMLDivElement

- Defined in Grid3/Grid.ts:282

### Private selectorMain

selectorMain: HTMLDivElement

- Defined in Grid3/Grid.ts:273

### Private selectorMainContainer

selectorMainContainer: HTMLDivElement

- Defined in Grid3/Grid.ts:271

### Private selectorMainContainerPosition

selectorMainContainerPosition: HTMLDivElement

- Defined in Grid3/Grid.ts:272

### Private selectorRows

selectorRows: HTMLDivElement

- Defined in Grid3/Grid.ts:280

### Private selectorRowsContainer

selectorRowsContainer: HTMLDivElement

- Defined in Grid3/Grid.ts:278

### Private selectorRowsContainerPosition

selectorRowsContainerPosition: HTMLDivElement

- Defined in Grid3/Grid.ts:279

### Private selectorWrapper

selectorWrapper: HTMLDivElement

- Defined in Grid3/Grid.ts:270

### Private shiftDown

shiftDown: boolean = false

- Defined in Grid3/Grid.ts:331

### Private styles

styles: IGridContentStyles = []

- Defined in Grid3/Grid.ts:305

### touch

touch: boolean = false

- Defined in Grid3/Grid.ts:219

### tracking

tracking: boolean = false

Implementation of IGrid.tracking

- Defined in Grid3/Grid.ts:174

### trackingData

trackingData: ITrackingData[] | undefined

- Defined in Grid3/Grid.ts:175

### Private trackingUsers

trackingUsers: number[] = []

- Defined in Grid3/Grid.ts:302

### Private unshift

unshift: boolean = false

- Defined in Grid3/Grid.ts:333

### userId

userId: number = 0

Implementation of IGrid.userId

- Defined in Grid3/Grid.ts:179

### Private width

width: number = 0

- Defined in Grid3/Grid.ts:194

### Private wrapperEl

wrapperEl: HTMLDivElement

- Defined in Grid3/Grid.ts:242

### Private wrapperElRect

wrapperElRect: ClientRect

- Defined in Grid3/Grid.ts:243

## Accessors

### Private editing

- get editing(): boolean
- set editing(n: boolean): void

- - Defined in Grid3/Grid.ts:1467

  #### Returns boolean

- - Defined in Grid3/Grid.ts:1471

  #### Parameters

  - ##### n: boolean

  #### Returns void

### gridlines

- get gridlines(): boolean
- set gridlines(n: boolean): void

- - Defined in Grid3/Grid.ts:1441

  #### Returns boolean

- - Defined in Grid3/Grid.ts:1445

  #### Parameters

  - ##### n: boolean

  #### Returns void

### hasFocus

- get hasFocus(): boolean
- set hasFocus(n: boolean): void

- - Defined in Grid3/Grid.ts:1428

  #### Returns boolean

- - Defined in Grid3/Grid.ts:1432

  #### Parameters

  - ##### n: boolean

  #### Returns void

### headings

- get headings(): boolean
- set headings(n: boolean): void

- - Defined in Grid3/Grid.ts:1454

  #### Returns boolean

- - Defined in Grid3/Grid.ts:1458

  #### Parameters

  - ##### n: boolean

  #### Returns void

## Methods

### Private applyButtons

- applyButtons(): void

- - Defined in Grid3/Grid.ts:547

  #### Returns void

### Private applyCellUpdate

- applyCellUpdate(rowIndex: number, colIndex: number, which: string, value: any): void

- - Defined in Grid3/Grid.ts:572

  #### Parameters

  - ##### rowIndex: number

  - ##### colIndex: number

  - ##### which: string

  - ##### value: any

  #### Returns void

### Private applyFilters

- applyFilters(): void

- - Defined in Grid3/Grid.ts:3071

  #### Returns void

### Private applyHeadingCellsFreeze

- applyHeadingCellsFreeze(): void

- - Defined in Grid3/Grid.ts:1098

  #### Returns void

### Private applyRanges

- applyRanges(): void

- - Defined in Grid3/Grid.ts:560

  #### Returns void

### Private applyScale

- applyScale(): void

- - Defined in Grid3/Grid.ts:1310

  #### Returns void

### Private applySorting

- applySorting(): void

- - Defined in Grid3/Grid.ts:3042

  #### Returns void

### Private applyState

- applyState(update?: boolean): void

- - Defined in Grid3/Grid.ts:1337

  #### Parameters

  - ##### Default value update: boolean = false

  #### Returns void

### Private applyStyles

- applyStyles(): void

- - Defined in Grid3/Grid.ts:534

  #### Returns void

### Private cancelCellEdit

- cancelCellEdit(restore?: undefined | false | true): void

- - Defined in Grid3/Grid.ts:1646

  #### Parameters

  - ##### Optional restore: undefined | false | true

  #### Returns void

### clearFound

- clearFound(): void

- - Defined in Grid3/Grid.ts:1040

  #### Returns void

### clearSelector

- clearSelector(): void

- - Defined in Grid3/Grid.ts:1070

  #### Returns void

### clearTrackingData

- clearTrackingData(): void

- - Defined in Grid3/Grid.ts:1054

  #### Returns void

### Private createListeners

- createListeners(): void

- - Defined in Grid3/Grid.ts:2965

  #### Returns void

### destroy

- destroy(): void

- Implementation of IGrid.destroy

  - Defined in Grid3/Grid.ts:382

  #### Returns void

### Private destroyListeners

- destroyListeners(): void

- - Defined in Grid3/Grid.ts:3027

  #### Returns void

### Private destroyPopper

- destroyPopper(): void

- - Defined in Grid3/Grid.ts:1578

  #### Returns void

### Private dom

- dom(): void

- - Defined in Grid3/Grid.ts:2533

  #### Returns void

### Private domHeadings

- domHeadings(): void

- - Defined in Grid3/Grid.ts:2695

  #### Returns void

### Private emitSelected

- emitSelected(evt: any, type?: undefined | string): void

- - Defined in Grid3/Grid.ts:2118

  #### Parameters

  - ##### evt: any

  - ##### Optional type: undefined | string

  #### Returns void

### find

- find(query: string): void

- Implementation of IGrid.find

  - Defined in Grid3/Grid.ts:990

  #### Parameters

  - ##### query: string

  #### Returns void

### Private getCell

- getCell(evtTarget: any): any

- - Defined in Grid3/Grid.ts:2940

  #### Parameters

  - ##### evtTarget: any

  #### Returns any

### getContentHtml

- getContentHtml(): string

- Implementation of IGrid.getContentHtml

  - Defined in Grid3/Grid.ts:964

  #### Returns string

### getGridCell

- getGridCell(rowIndex: number, colIndex: number, original?: undefined | false | true): IGridCell | null

- - Defined in Grid3/Grid.ts:945

  #### Parameters

  - ##### rowIndex: number

  - ##### colIndex: number

  - ##### Optional original: undefined | false | true

  #### Returns IGridCell | null

### Private getGridCellByTarget

- getGridCellByTarget(target: EventTarget | null): IGridCell | IGridHeadingCell | null

- - Defined in Grid3/Grid.ts:2217

  #### Parameters

  - ##### target: EventTarget | null

  #### Returns IGridCell | IGridHeadingCell | null

### Private getTrackingUser

- getTrackingUser(userId: number): number

- - Defined in Grid3/Grid.ts:2523

  #### Parameters

  - ##### userId: number

  #### Returns number

### init

- init(): void

- - Defined in Grid3/Grid.ts:353

  #### Returns void

### Private isFullyVisible

- isFullyVisible(cell: IGridCell, axis?: undefined | string): boolean

- - Defined in Grid3/Grid.ts:2713

  #### Parameters

  - ##### cell: IGridCell

  - ##### Optional axis: undefined | string

  #### Returns boolean

### Private isInsideSelection

- isInsideSelection(gridCell: IGridCell | IGridHeadingCell): boolean

- - Defined in Grid3/Grid.ts:2161

  #### Parameters

  - ##### gridCell: IGridCell | IGridHeadingCell

  #### Returns boolean

### Private isRightClick

- isRightClick(evt: any): boolean

- - Defined in Grid3/Grid.ts:2954

  #### Parameters

  - ##### evt: any

  #### Returns boolean

### Private isTarget

- isTarget(evtTarget: any, element: HTMLElement): boolean

- - Defined in Grid3/Grid.ts:2932

  #### Parameters

  - ##### evtTarget: any

  - ##### element: HTMLElement

  #### Returns boolean

### Private isVisible

- isVisible(cell: IGridCell | IGridHeadingCell | IGridRow, axis?: undefined | string): boolean

- - Defined in Grid3/Grid.ts:2734

  #### Parameters

  - ##### cell: IGridCell | IGridHeadingCell | IGridRow

  - ##### Optional axis: undefined | string

  #### Returns boolean

### Private onCellUpdates

- onCellUpdates(): void

- - Defined in Grid3/Grid.ts:1586

  #### Returns void

### Private onCtrlNavigate

- onCtrlNavigate(which: string): boolean

- - Defined in Grid3/Grid.ts:1963

  #### Parameters

  - ##### which: string

  #### Returns boolean

### Private onKeydown

- onKeydown(evt: KeyboardEvent): void

- - Defined in Grid3/Grid.ts:1844

  #### Parameters

  - ##### evt: KeyboardEvent

  #### Returns void

### Private onKeyup

- onKeyup(evt: KeyboardEvent): void

- - Defined in Grid3/Grid.ts:1949

  #### Parameters

  - ##### evt: KeyboardEvent

  #### Returns void

### Private onMouseDown

- onMouseDown(evt: any): void

- - Defined in Grid3/Grid.ts:1653

  #### Parameters

  - ##### evt: any

  #### Returns void

### Private onMouseMove

- onMouseMove(e: MouseEvent): void

- - Defined in Grid3/Grid.ts:1771

  #### Parameters

  - ##### e: MouseEvent

  #### Returns void

### Private onMouseUp

- onMouseUp(evt: any): void

- - Defined in Grid3/Grid.ts:1790

  #### Parameters

  - ##### evt: any

  #### Returns void

### Private onResize

- onResize(): void

- - Defined in Grid3/Grid.ts:1572

  #### Returns void

### Private onResizeHandle

- onResizeHandle(gridCell: IGridHeadingCell): void

- - Defined in Grid3/Grid.ts:1736

  #### Parameters

  - ##### gridCell: IGridHeadingCell

  #### Returns void

### Private render

- render(): void

- - Defined in Grid3/Grid.ts:2765

  #### Returns void

### reset

- reset(): void

- Implementation of IGrid.reset

  - Defined in Grid3/Grid.ts:359

  #### Returns void

### Private scaleDimension

- scaleDimension(n: number): number

- - Defined in Grid3/Grid.ts:2761

  #### Parameters

  - ##### n: number

  #### Returns number

### Private selectNextCell

- selectNextCell(direction: string, key?: string): void

- - Defined in Grid3/Grid.ts:2236

  #### Parameters

  - ##### direction: string

  - ##### Default value key: string = ""

  #### Returns void

### Private setCellSelection

- setCellSelection(target: any): IGridCell | IGridHeadingCell | null

- - Defined in Grid3/Grid.ts:2185

  #### Parameters

  - ##### target: any

  #### Returns IGridCell | IGridHeadingCell | null

### setContent

- setContent(content: IGridPageContent, state?: IGridState): void

- - Defined in Grid3/Grid.ts:601

  Set grid content from Page. Resets grid state and settings then create all new grid cell references. Use when first loading a Page or the Page size has changed.

  #### Parameters

  - ##### content: IGridPageContent

    Page content.

  - ##### Optional state: IGridState

    Grid state. Sorting, Filters, Hidden Columns

  #### Returns void

### setContrast

- setContrast(which: string): void

- Implementation of IGrid.setContrast

  - Defined in Grid3/Grid.ts:939

  #### Parameters

  - ##### which: string

  #### Returns void

### setDeltaContent

- setDeltaContent(content: IPageContent): void

- - Defined in Grid3/Grid.ts:720

  Update grid cell values. Use when there is new content from a Page.

  #### Parameters

  - ##### content: IPageContent

    Cells that have changed.

  #### Returns void

### Private setElementSizes

- setElementSizes(which: string, size: number): void

- - Defined in Grid3/Grid.ts:1116

  #### Parameters

  - ##### which: string

  - ##### size: number

  #### Returns void

### setFreeze

- setFreeze(row: number, col: number, headings?: undefined | false | true): void

- Implementation of IGrid.setFreeze

  - Defined in Grid3/Grid.ts:786

  Freeze rows/columns. Use when a Page is ready and only after setContent() has been applied.

  #### Parameters

  - ##### row: number

  - ##### col: number

  - ##### Optional headings: undefined | false | true

  #### Returns void

### Private setFreezeSizes

- setFreezeSizes(): void

- - Defined in Grid3/Grid.ts:1152

  #### Returns void

### setHiddenColumns

- setHiddenColumns(columns: number[]): void

- Implementation of IGrid.setHiddenColumns

  - Defined in Grid3/Grid.ts:393

  #### Parameters

  - ##### columns: number[]

  #### Returns void

### setOption

- setOption(key: string, value: any): void

- Implementation of IGrid.setOption

  - Defined in Grid3/Grid.ts:388

  #### Parameters

  - ##### key: string

  - ##### value: any

  #### Returns void

### Private setPositions

- setPositions(cellRef: IGridHeadingCell, data: IGridHeadingCellResizing): void

- - Defined in Grid3/Grid.ts:1511
  description

    After resizing set the final cell offets and update grid size

  #### Parameters

  - ##### cellRef: IGridHeadingCell

  - ##### data: IGridHeadingCellResizing

  #### Returns void

### setSelector

- setSelector(from: IGridContentCellPosition, to: IGridContentCellPosition): void

- - Defined in Grid3/Grid.ts:1076

  #### Parameters

  - ##### from: IGridContentCellPosition

  - ##### to: IGridContentCellPosition

  #### Returns void

### setSelectorByRef

- setSelectorByRef(str: string): void

- Implementation of IGrid.setSelectorByRef

  - Defined in Grid3/Grid.ts:1086

  #### Parameters

  - ##### str: string

  #### Returns void

### Private setSize

- setSize(cellRef: IGridHeadingCell, data: IGridHeadingCellResizing): void

- - Defined in Grid3/Grid.ts:1221

  #### Parameters

  - ##### cellRef: IGridHeadingCell

  - ##### data: IGridHeadingCellResizing

  #### Returns void

### update

- update(scale?: undefined | number): void

- Implementation of IGrid.update

  - Defined in Grid3/Grid.ts:1021

  Display the grid. Use after setContent().

  #### Parameters

  - ##### Optional scale: undefined | number

  #### Returns void

### updateButtons

- updateButtons(buttons?: IActionsButton[]): void

- Implementation of IGrid.updateButtons

  - Defined in Grid3/Grid.ts:405

  #### Parameters

  - ##### Optional buttons: IActionsButton[]

  #### Returns void

### updateFit

- updateFit(fit: string): void

- Implementation of IGrid.updateFit

  - Defined in Grid3/Grid.ts:933

  #### Parameters

  - ##### fit: string

  #### Returns void

### updateFreeze

- updateFreeze(row: number, col: number, headings?: undefined | false | true): void

- Implementation of IGrid.updateFreeze

  - Defined in Grid3/Grid.ts:915

  #### Parameters

  - ##### row: number

  - ##### col: number

  - ##### Optional headings: undefined | false | true

  #### Returns void

### updateHeadings

- updateHeadings(headings: boolean): void

- - Defined in Grid3/Grid.ts:897

  #### Parameters

  - ##### headings: boolean

  #### Returns void

### Private updateHistoryCells

- updateHistoryCells(): void

- - Defined in Grid3/Grid.ts:2495

  #### Returns void

### updateRanges

- updateRanges(ranges: any, userId?: number): void

- - Defined in Grid3/Grid.ts:464

  #### Parameters

  - ##### ranges: any

  - ##### Default value userId: number = 0

  #### Returns void

### Private updateSelector

- updateSelector(set?: string, type?: string): void

- - Defined in Grid3/Grid.ts:2329

  #### Parameters

  - ##### Default value set: string = ""

  - ##### Default value type: string = ""

  #### Returns void

### updateSize

- updateSize(): void

- - Defined in Grid3/Grid.ts:1010

  #### Returns void

### Private updateSoftMerges

- updateSoftMerges(rows?: any[]): void

- - Defined in Grid3/Grid.ts:1198

  #### Parameters

  - ##### Default value rows: any[] = []

  #### Returns void

### updateSorting

- updateSorting(sorting?: any): void

- Implementation of IGrid.updateSorting

  - Defined in Grid3/Grid.ts:397

  #### Parameters

  - ##### Optional sorting: any

  #### Returns void

### updateState

- updateState(state: IGridState): void

- Implementation of IGrid.updateState

  - Defined in Grid3/Grid.ts:766

  Sort, Filter and/or show/hide Columns.

  #### Parameters

  - ##### state: IGridState

  #### Returns void

### updateStyles

- updateStyles(styles?: IGridContentStyles): void

- Implementation of IGrid.updateStyles

  - Defined in Grid3/Grid.ts:443

  #### Parameters

  - ##### Optional styles: IGridContentStyles

  #### Returns void

### updateTrackingData

- updateTrackingData(trackingData: ITrackingData[]): void

- Implementation of IGrid.updateTrackingData

  - Defined in Grid3/Grid.ts:773

  #### Parameters

  - ##### trackingData: ITrackingData[]

  #### Returns void

## Object literals

### Private selection

selection: object

- Defined in Grid3/Grid.ts:310

### colFrom

colFrom: number = 0

- Defined in Grid3/Grid.ts:318

### colLast

colLast: number = 0

- Defined in Grid3/Grid.ts:319

### colTo

colTo: number = 0

- Defined in Grid3/Grid.ts:317

### heading

heading: false = false

- Defined in Grid3/Grid.ts:320

### inside

inside: false = false

- Defined in Grid3/Grid.ts:321

### keyboard

keyboard: false = false

- Defined in Grid3/Grid.ts:323

### reference

reference: string = ""

- Defined in Grid3/Grid.ts:322

### rowEnd

rowEnd: number = 0

- Defined in Grid3/Grid.ts:315

### rowFrom

rowFrom: number = 0

- Defined in Grid3/Grid.ts:312

### rowLast

rowLast: number = 0

- Defined in Grid3/Grid.ts:316

### rowStart

rowStart: number = 0

- Defined in Grid3/Grid.ts:314

### rowTo

rowTo: number = 0

- Defined in Grid3/Grid.ts:313

### selected

selected: false = false

- Defined in Grid3/Grid.ts:311

### type

type: string = "cell"

- Defined in Grid3/Grid.ts:324

### state

state: object

Implementation of IGrid.state

- Defined in Grid3/Grid.ts:180

### filters

filters: never[] = []

- Defined in Grid3/Grid.ts:181

### hiddenColumns

hiddenColumns: never[] = []

- Defined in Grid3/Grid.ts:182

### sorting

sorting: object

- Defined in Grid3/Grid.ts:183

### col

col: number = -1

- Defined in Grid3/Grid.ts:184

### direction

direction: ASC = IGridSortDirection.ASC

- Defined in Grid3/Grid.ts:186

### enabled

enabled: false = false

- Defined in Grid3/Grid.ts:187

### field

field: string = ""

- Defined in Grid3/Grid.ts:185

### type

type: STRING = IGridFieldType.STRING

- Defined in Grid3/Grid.ts:188

Generated using TypeDoc